Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access/3.3/Properties/AssemblyInfo.frame
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access/3.3/Properties/AssemblyInfo.frame	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access/3.3/Properties/AssemblyInfo.frame	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -32,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
Index: /branches/ClientUserManagement/HeuristicLab.GeoIP/1.12/GeoIPLookupService.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.GeoIP/1.12/GeoIPLookupService.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.GeoIP/1.12/GeoIPLookupService.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.GeoIP/1.12/Properties/AssemblyInfo.frame
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.GeoIP/1.12/Properties/AssemblyInfo.frame	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.GeoIP/1.12/Properties/AssemblyInfo.frame	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -32,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/MockUserManager.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/MockUserManager.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/MockUserManager.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/UnitTest.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/UnitTest.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/UnitTest.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/Properties/AssemblyInfo.frame
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/Properties/AssemblyInfo.frame	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/Properties/AssemblyInfo.frame	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -32,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/AccessService.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/AccessService.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/AccessService.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -41,4 +41,12 @@
     }
 
+    private IRoleVerifier roleVerifier;
+    private IRoleVerifier RoleVerifier {
+      get {
+        if (roleVerifier == null) roleVerifier = new RoleVerifier();
+        return roleVerifier;
+      }
+    }
+
     #region Client Members
     public bool ClientExists(Guid id) {
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Convert.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Convert.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Convert.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/AccessItem.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/AccessItem.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/AccessItem.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Client.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Client.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Client.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientConfiguration.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientConfiguration.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientConfiguration.cs	(revision 7355)
@@ -2,5 +2,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientError.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientError.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientError.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientGroup.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientGroup.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientGroup.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientGroupMapping.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientGroupMapping.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientGroupMapping.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientLog.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientLog.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientLog.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientType.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientType.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/ClientType.cs	(revision 7355)
@@ -2,5 +2,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Country.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Country.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Country.cs	(revision 7355)
@@ -2,5 +2,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/OperatingSystem.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/OperatingSystem.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/OperatingSystem.cs	(revision 7355)
@@ -2,5 +2,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Plugin.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Plugin.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Plugin.cs	(revision 7355)
@@ -2,5 +2,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Resource.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Resource.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Resource.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Role.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Role.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/Role.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab 
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
  * 
  * This file is part of HeuristicLab. 
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/User.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/User.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/User.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab 
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
  * 
  * This file is part of HeuristicLab. 
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/UserGroup.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/UserGroup.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/UserGroup.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab 
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
  * 
  * This file is part of HeuristicLab. 
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/UserGroupBase.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/UserGroupBase.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/UserGroupBase.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/UserGroupMapping.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/UserGroupMapping.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/DataTransfer/UserGroupMapping.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/HeuristicLab.Services.Access-3.3.csproj
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/HeuristicLab.Services.Access-3.3.csproj	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/HeuristicLab.Services.Access-3.3.csproj	(revision 7355)
@@ -73,7 +73,9 @@
     <Compile Include="DataTransfer\UserGroupMapping.cs" />
     <Compile Include="IAccessService.cs" />
+    <Compile Include="Interfaces\IRoleVerifier.cs" />
     <Compile Include="Interfaces\IUserManager.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="AccessService.cs" />
+    <Compile Include="RoleVerifier.cs" />
     <Compile Include="UserManager.cs" />
   </ItemGroup>
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/IAccessService.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/IAccessService.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/IAccessService.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IRoleVerifier.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IRoleVerifier.cs	(revision 7355)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IRoleVerifier.cs	(revision 7355)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Services.Access {
+  public interface IRoleVerifier {
+
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IUserManager.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IUserManager.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IUserManager.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Properties/AssemblyInfo.frame
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Properties/AssemblyInfo.frame	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Properties/AssemblyInfo.frame	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -32,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/RoleVerifier.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/RoleVerifier.cs	(revision 7355)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/RoleVerifier.cs	(revision 7355)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using System.Security;
+using System.Web.Security;
+
+namespace HeuristicLab.Services.Access {
+  public class RoleVerifier : IRoleVerifier {
+    public bool IsInRole(string role) {
+      return Roles.IsUserInRole(role);
+    }
+    public bool IsInAnyRole(params string[] roles) {
+      return roles.Any(x => Roles.IsUserInRole(x));
+    }
+    public bool IsInAllRoles(params string[] roles) {
+      return roles.All(x => Roles.IsUserInRole(x));
+    }
+    public void AuthenticateForAnyRole(params string[] roles) {
+      if (!IsInAnyRole(roles))
+        throw new SecurityException("Could not authenticate user for any role required.");
+    }
+    public void AuthenticateForAllRoles(params string[] roles) {
+      if (!IsInAllRoles(roles))
+        throw new SecurityException("Could not authenticate user for all roles required.");
+    }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/UserManager.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/UserManager.cs	(revision 7354)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/UserManager.cs	(revision 7355)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.