Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/AccessServiceLocator.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/AccessServiceLocator.cs	(revision 7358)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/AccessServiceLocator.cs	(revision 7358)
@@ -0,0 +1,49 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Services.Access {
+  public class AccessServiceLocator : IAccessServiceLocator {
+    private static IAccessServiceLocator instance;
+    public static IAccessServiceLocator Instance {
+      get {
+        if (instance == null) instance = new AccessServiceLocator();
+        return instance;
+      }
+      set { instance = value; }
+    }
+
+    private IRoleVerifier roleVerifier;
+    public IRoleVerifier RoleVerifier {
+      get {
+        if (roleVerifier == null) roleVerifier = new RoleVerifier();
+        return roleVerifier;
+      }
+    }
+
+    private IUserManager userManager;
+    public IUserManager UserManager {
+      get {
+        if (userManager == null) userManager = new UserManager();
+        return userManager;
+      }
+    }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/HeuristicLab.Services.Access-3.3.csproj
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/HeuristicLab.Services.Access-3.3.csproj	(revision 7357)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/HeuristicLab.Services.Access-3.3.csproj	(revision 7358)
@@ -54,4 +54,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="AccessServiceLocator.cs" />
     <Compile Include="Convert.cs" />
     <Compile Include="DataTransfer\Client.cs" />
@@ -73,4 +74,5 @@
     <Compile Include="DataTransfer\UserGroupMapping.cs" />
     <Compile Include="IAccessService.cs" />
+    <Compile Include="Interfaces\IAccessServiceLocator.cs" />
     <Compile Include="Interfaces\IRoleVerifier.cs" />
     <Compile Include="Interfaces\IUserManager.cs" />
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IAccessServiceLocator.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IAccessServiceLocator.cs	(revision 7358)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IAccessServiceLocator.cs	(revision 7358)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Services.Access {
+  public interface IAccessServiceLocator {
+    IRoleVerifier RoleVerifier { get; }
+    IUserManager UserManager { get; }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IRoleVerifier.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IRoleVerifier.cs	(revision 7357)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access/3.3/Interfaces/IRoleVerifier.cs	(revision 7358)
@@ -20,8 +20,11 @@
 #endregion
 
-
 namespace HeuristicLab.Services.Access {
   public interface IRoleVerifier {
-
+    bool IsInRole(string role);
+    bool IsInAnyRole(params string[] roles);
+    bool IsInAllRoles(params string[] roles);
+    void AuthenticateForAnyRole(params string[] roles);
+    void AuthenticateForAllRoles(params string[] roles);
   }
 }