Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceConfiguration.Cloud.cscfg
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceConfiguration.Cloud.cscfg	(revision 7370)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceConfiguration.Cloud.cscfg	(revision 7371)
@@ -4,5 +4,4 @@
     <Instances count="1" />
     <ConfigurationSettings>
-      <Setting name="Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString" value="DefaultEndpointsProtocol=https;AccountName=hivestorage;AccountKey=Idq7D7dTvhpByPproP//rmdEaU5gmRxG62jAnJdghgzKqolnzsWjVTwNbg3p5BXVl86FuAXqvKlUAYFrMuSCMw==" />
       <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.Enabled" value="true" />
       <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.AccountUsername" value="hive" />
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceConfiguration.Local.cscfg
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceConfiguration.Local.cscfg	(revision 7370)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceConfiguration.Local.cscfg	(revision 7371)
@@ -4,5 +4,4 @@
     <Instances count="1" />
     <ConfigurationSettings>
-      <Setting name="Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString" value="UseDevelopmentStorage=true" />
       <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.Enabled" value="true" />
       <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.AccountUsername" value="hive" />
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceDefinition.build.csdef
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceDefinition.build.csdef	(revision 7370)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceDefinition.build.csdef	(revision 7371)
@@ -12,5 +12,4 @@
   <WorkerRole name="HeuristicLab.Clients.Hive.Slave.AzureClient" vmsize="Small">
     <Imports>
-      <Import moduleName="Diagnostics" />
       <Import moduleName="RemoteAccess" />
       <Import moduleName="RemoteForwarder" />
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceDefinition.csdef
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceDefinition.csdef	(revision 7370)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.Azure/ServiceDefinition.csdef	(revision 7371)
@@ -3,5 +3,4 @@
   <WorkerRole name="HeuristicLab.Clients.Hive.Slave.AzureClient" vmsize="Small">
     <Imports>
-      <Import moduleName="Diagnostics" />
       <Import moduleName="RemoteAccess" />
       <Import moduleName="RemoteForwarder" />
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.AzureClient/Constants.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.AzureClient/Constants.cs	(revision 7371)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.AzureClient/Constants.cs	(revision 7371)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Clients.Hive.Slave.AzureClient {
+  public static class Constants {
+    public const string DiagnosticsConnectionString = "Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString";
+  }
+}
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.AzureClient/HeuristicLab.Clients.Hive.Slave.AzureClient.csproj
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.AzureClient/HeuristicLab.Clients.Hive.Slave.AzureClient.csproj	(revision 7370)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.AzureClient/HeuristicLab.Clients.Hive.Slave.AzureClient.csproj	(revision 7371)
@@ -62,4 +62,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Constants.cs" />
     <Compile Include="WorkerRole.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.AzureClient/WorkerRole.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.AzureClient/WorkerRole.cs	(revision 7370)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.Slave.AzureClient/WorkerRole.cs	(revision 7371)
@@ -18,5 +18,4 @@
       while (true) {
         Thread.Sleep(10000);
-        //Trace.WriteLine("Working", "Information");
       }
     }
@@ -25,9 +24,17 @@
       ServicePointManager.DefaultConnectionLimit = 12;
       core = new Core();
-
-      DiagnosticMonitorConfiguration dmc = DiagnosticMonitor.GetDefaultInitialConfiguration();
-      dmc.Logs.ScheduledTransferPeriod = TimeSpan.FromMinutes(1);
-      dmc.Logs.ScheduledTransferLogLevelFilter = LogLevel.Verbose;
-      DiagnosticMonitor.Start("Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString", dmc);
+      try {
+        if (!String.IsNullOrEmpty(RoleEnvironment.GetConfigurationSettingValue(Constants.DiagnosticsConnectionString))) {
+          DiagnosticMonitorConfiguration dmc = DiagnosticMonitor.GetDefaultInitialConfiguration();
+          dmc.Logs.ScheduledTransferPeriod = TimeSpan.FromMinutes(1);
+          dmc.Logs.ScheduledTransferLogLevelFilter = LogLevel.Verbose;
+          DiagnosticMonitor.Start(Constants.DiagnosticsConnectionString, dmc);
+        }
+      }
+      catch (RoleEnvironmentException ex) {
+        //diagnostics connectio string not in configuration
+        //-> diagnostics disabled
+        //nothing more to do
+      }
 
       return base.OnStart();